/*---------------------------------------------------------*/
//
// SpinCtrlBug.c
//
/*---------------------------------------------------------*/

#include <windows.h>
#include <commctrl.h>

#include "resource.h"

/*---------------------------------------------------------*/

static HWND hWnd;
static HINSTANCE hInst;
static char *pPRGCLASS = "SpinCtrlBug";

static HWND hwnd_dialog = NULL;

static char tab_selected;

static HWND hwndtab1;
static HWND hwndtab2;
static HWND hwndtab3;

/*---------------------------------------------------------*/

void expand_window_to_max(HWND hDlg)
{
    POINT p;
    RECT r;


    if (hWnd) {
        GetClientRect(hWnd,&r);
        p.x = p.y = 0;
        ClientToScreen(hWnd,&p);
        MoveWindow(hDlg,p.x,p.y,r.right-r.left,r.bottom-r.top,FALSE);
        }
}

/*---------------------------------------------------------*/

static void posiziona_tab_window(HWND hDlg)
{
    HWND hParent;
    RECT r1,r2;
    POINT p;
    int x,y;


    hParent = GetParent(hDlg);

    GetWindowRect(GetDlgItem(hParent,IDC_FRAME_TAB),&r1);
    GetWindowRect(hDlg,&r2);

    p.x = r1.left;
    p.y = r1.top;
    ScreenToClient(hParent,&p);
    x = p.x+2;
    y = p.y+2;

    MoveWindow(hDlg,x,y,r2.right-r2.left,r2.bottom-r2.top,FALSE);
}

/*---------------------------------------------------------*/

static void gestione_scheda(HWND hDlg)
{
    int i = 0;


    if (IsDlgButtonChecked(hDlg,IDC_RADIO1)) {
        i = 1;
        }
    else if (IsDlgButtonChecked(hDlg,IDC_RADIO2)) {
        i = 2;
        }
    else {
        i = 3;
        }

    if (i!=0 && i!=tab_selected) {
        switch (tab_selected) {
            case 1:
                ShowWindow(hwndtab1,SW_HIDE);
                break;
            case 2:
                ShowWindow(hwndtab2,SW_HIDE);
                break;
            case 3:
                ShowWindow(hwndtab3,SW_HIDE);
                break;
            }
        tab_selected = i;
        switch (tab_selected) {
            case 1:
                ShowWindow(hwndtab1,SW_SHOW);
                break;
            case 2:
                ShowWindow(hwndtab2,SW_SHOW);
                break;
            case 3:
                ShowWindow(hwndtab3,SW_SHOW);
                break;
            }
        }
}

/*---------------------------------------------------------*/

static BOOL CALLBACK TabProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
    switch (message) {
        case WM_INITDIALOG:
            posiziona_tab_window(hDlg);
            return(TRUE);

        case WM_COMMAND :
            switch (LOWORD(wParam)) {
                }
            break;
        }

    return(FALSE);
}

/*---------------------------------------------------------*/

static void init_mask(HWND hDlg,int with_bug)
{
    CheckDlgButton(hDlg,IDC_RADIO1,TRUE);

    tab_selected = 1;

    hwndtab1 = CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_TAB1),hDlg,(DLGPROC)TabProc,1);
    hwndtab2 = CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_TAB2),hDlg,(DLGPROC)TabProc,2);
    if (with_bug) {
        hwndtab3 = CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_TAB4),hDlg,(DLGPROC)TabProc,3);
        }
    else {
        hwndtab3 = CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_TAB3),hDlg,(DLGPROC)TabProc,3);
        }

    ShowWindow(hwndtab1,SW_SHOW);
}

/*---------------------------------------------------------*/

BOOL CALLBACK DialogProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
    switch (message) {
        case WM_INITDIALOG :
            expand_window_to_max(hDlg);
            init_mask(hDlg,(int)lParam);
            return(TRUE);
            
        case WM_COMMAND :
            switch (LOWORD(wParam)) {
                case IDC_RADIO1:
                case IDC_RADIO2:
                case IDC_RADIO3:
                    gestione_scheda(hDlg);
                    break;

                case IDCANCEL:
                    if (hwndtab1) {
                        DestroyWindow(hwndtab1);
                        hwndtab1 = NULL;
                        }
                    if (hwndtab2) {
                        DestroyWindow(hwndtab2);
                        hwndtab2 = NULL;
                        }
                    if (hwndtab3) {
                        DestroyWindow(hwndtab3);
                        hwndtab3 = NULL;
                        }
                    DestroyWindow(hDlg);
                    hwnd_dialog = NULL;
                    break;
                }
            break;
        }
    
    return(FALSE);
}

/*---------------------------------------------------------*/

static void create_dialog1(HWND hWnd)
{
    if (hwnd_dialog = CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_DIALOG1),hWnd,(DLGPROC)DialogProc,TRUE)) {
        ShowWindow(hwnd_dialog,SW_SHOW);
        }
}

/*---------------------------------------------------------*/

static void create_dialog2(HWND hWnd)
{
    if (hwnd_dialog = CreateDialogParam(hInst,MAKEINTRESOURCE(IDD_DIALOG1),hWnd,(DLGPROC)DialogProc,FALSE)) {
        ShowWindow(hwnd_dialog,SW_SHOW);
        }
}

/*---------------------------------------------------------*/

LRESULT CALLBACK MainWndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam)
{
    switch (message) {
        case WM_CREATE:
            hWnd = hwnd;
            return(FALSE);

        case WM_COMMAND:
            switch (LOWORD(wParam)) {
                case ID_MENU_DIALOGWITHBUG:
                    create_dialog1(hwnd);
                    break;

                case ID_MENU_DIALOGWITHOUTBUG:
                    create_dialog2(hwnd);
                    break;

                case ID_MENU_FINE:
                    DestroyWindow(hwnd);
                    break;
                }
            break;

        case WM_DESTROY:
            PostQuitMessage(0);
            break;

        default:
            return(DefWindowProc(hwnd,message,wParam,lParam));
        }

    return(FALSE);
}


/*---------------------------------------------------------*/

BOOL InitApplication(HINSTANCE hInstance)
{
    WNDCLASS  wc;


    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = (WNDPROC)MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
    wc.lpszClassName = pPRGCLASS;

    return(RegisterClass(&wc));
}

/*---------------------------------------------------------*/

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    if (CreateWindow(pPRGCLASS,"SpinCtrlBug",WS_OVERLAPPEDWINDOW,
                     CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                     NULL,NULL,hInstance,NULL)) {
        ShowWindow(hWnd,nCmdShow);
        UpdateWindow(hWnd);

        return(TRUE);
        }

    return(FALSE);
}

/*---------------------------------------------------------*/

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
    INITCOMMONCONTROLSEX icc;
    MSG msg;


    hInst = hInstance;

    ZeroMemory(&icc,sizeof(icc));
    icc.dwSize = sizeof(icc);
    icc.dwICC = ICC_WIN95_CLASSES|ICC_DATE_CLASSES;
    InitCommonControlsEx(&icc);

    if (!InitApplication(hInstance)) {
        return (FALSE);
        }

    if (!InitInstance(hInstance,nCmdShow)) {
        return (FALSE);
        }

    while (GetMessage(&msg,NULL,0,0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
        }

    return((int)msg.wParam);
}

/*---------------------------------------------------------*/
